import * as React from 'react';
// @ts-ignore
import { MDCMenuSurfaceFoundation, MDCMenuSurfaceAdapter, Corner } from '@material/menu-surface/dist/mdc.menuSurface';
export interface MenuSurfaceProps extends React.HTMLProps<HTMLDivElement> {
    className: string;
    anchorElement?: HTMLElement;
    anchorCorner: number;
    anchorMargin?: {
        top?: number;
        left?: number;
        bottom?: number;
        right?: number;
    };
    styles: React.CSSProperties;
    coordinates?: {
        x: number;
        y: number;
    };
    onClose: () => void;
    onOpen: () => void;
    onKeyDown: (event: React.KeyboardEvent) => void;
    quickOpen: boolean;
    open: boolean;
    fixed: boolean;
}
export interface MenuSurfaceState {
    transformOrigin: string;
    maxHeight?: number;
    styleLeft?: number;
    styleRight?: number;
    styleTop?: number;
    styleBottom?: number;
    classList: Set<string>;
}
declare class MenuSurface extends React.Component<MenuSurfaceProps, MenuSurfaceState> {
    menuSurfaceElement: React.RefObject<HTMLDivElement>;
    previousFocus: HTMLElement | null;
    foundation: MDCMenuSurfaceFoundation;
    handleWindowClick?: EventListener;
    registerWindowClickListener?: () => void;
    deregisterWindowClickListener?: () => void;
    firstFocusableElement: HTMLElement | null;
    lastFocusableElement: HTMLElement | null;
    state: MenuSurfaceState;
    static defaultProps: Partial<MenuSurfaceProps>;
    componentDidMount(): void;
    componentDidUpdate(prevProps: MenuSurfaceProps): void;
    componentWillUnmount(): void;
    private hoistToBody;
    private setCoordinates;
    readonly classes: string;
    readonly styles: React.CSSProperties;
    readonly adapter: MDCMenuSurfaceAdapter;
    open_: () => void;
    handleKeydown: (evt: React.KeyboardEvent<Element>) => void;
    render(): JSX.Element;
}
export default MenuSurface;
export { Corner };
